// Fichier Led.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Librairie de gestion des Leds		*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *  Les CAN doivent tre dsactive                     *
 ********************************************************/

#include <p18f452.h>		// Librairie du PIC utilis


#include "led.h"			// Entte de la librairie contenant les constantes




// --------------------------------------------------------------------------
/* Initialise le port de la led rouge en sortie
 *  Pas de paramtre
*/
void Led_Init (void)
{
	TRIS_LED_AMBRE=0;						// Configure le bit en sortie
	TRIS_LED_ROUGE=0;						// Configure le bit en sortie
	Led_Ambre(0);							// Eteind la led ambre
	Led_Rouge(0);							// Eteind la led rouge
}


// --------------------------------------------------------------------------
/* Commande la led ambre
 *  0 = Led teinte
 *  1 =Led allume
*/
void Led_Ambre (unsigned char Value)
{
	LED_AMBRE=!Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}



// --------------------------------------------------------------------------
/* Commande la led rouge
 *  0 = Led teinte
 *  1 =Led allume
*/
void Led_Rouge (unsigned char Value)
{
	LED_ROUGE=!Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}




