// Fichier Moteur.h
/////////////////////////////////////////////////////////

/****************************************************************
 *                                                    			*
 * .Date de cration : 11/01/08                         		*
 * .Auteur : Matthieu Cadic                             		*       
 *           Yohan Luzeau                                  		*
 * .Descriptions :                                      		*
 *      - Fichier header pour la gestion 				    	*
 *        du rouleau droit   									*
 *                                           					*
 *                                                      		*
 *																*
 ****************************************************************/


#define 	MOTEUR_PWM		PORTCbits.RC2				// Commande PWM du moteur
#define 	MOTEUR_DIR		PORTCbits.RC5				// Le sens de rotation du moteur

#define 	TRIS_MOTEUR_PWM		TRISCbits.TRISC2		// Direction du port pour le PWM
#define 	TRIS_MOTEUR_DIR		TRISCbits.TRISC5		// Direction du port pour le sens de rotation du moteur



//-----------------------------
// Prototype des fonctions

// --------------------------------------------------------------------------
/* Initialise la commande des moteurs
 * Configure les ports en sortie
 * Utilise le timer 2 pour gnrer le PWM
 * Arrte les moteur
*/
void Moteur_Init(void);




// --------------------------------------------------------------------------
/* Commande le moteur de la carte
 * Le paramtre reu est la vitesse dsire entre -1023 et +1023
 *  -1023 	: a fond en arrire
 *  0 		: moteur  l'arrt
 *  +1023	: a fond en avant 
 * Si la vitesse n'est pas comprise dans cet intervalle, elle est tronque
 * La vitesse rellement appliqu est retourne par la fonction
*/
int CommandeMoteur(int Vit);	
