#include "Triangulation.h"
#include <math.h>
#include <stdio.h>

int couleur = BLEU;

void TrierAngles(float * tab, int nb){
  	int i, j, imin;
    float min;

    for( i=0; i<nb; i++ ){

        // trouver le plus petit  partir de la ime position
		imin=i;
    	min = tab[i];

     	for( j=i+1; j<nb; j++ ){
			if( tab[j]<min ){
            	imin = j;
                min = tab[j];
            }
        }

        // permuter ce plus petit avec l'indice i
        tab[imin] = tab[i];
        tab[i] = min;

    }
}

void PermutCircu(float * tab, int nb){
	int i;
    float temp;

    temp = tab[0];
    for( i=1; i<nb; i++ ){
     	tab[i-1] = tab[i];
    }
    tab[nb-1] = temp;
}

float Angle( float xa, float ya, float xb, float yb, float x, float y ){
	float a,b,c, temp;

	b = (x-xa)*(x-xa) + (y-ya)*(y-ya);
	a = (x-xb)*(x-xb) + (y-yb)*(y-yb);

	// si M est confondu avec A ou B
    if( a==0 || b==0 ) {
		return -1;
    }
	c = (xa-xb)*(xa-xb) + (ya-yb)*(ya-yb);

	temp = (a+b-c)/2/sqrt(a)/sqrt(b);
    if( temp>1 ) 	return 0;
    if( temp<-1 ) 	return pi;

	return acos( temp );
}


void IntersectCercles( float a1, float b1, float a2, float b2, float x0, float y0,  float *X, float *Y ){
    float da = a2-a1;
    float db = b2-b1;
    float  H, det;
	
    H = -x0*da - y0*db;
    det = da*da + db*db;

    *X = 2*(db*(a1*b2-a2*b1)-da*H)/det - x0;
    *Y = -(H + da**X)/db ;
}


float CalcXY( float alpha1, float alpha2, float alpha3, float alpha4, float * X, float * Y ){
    float a1, b1, a2, b2, x0, y0;
    int methode;
	float alpha,ecart;
    float score=0;
	char v1=0, v2=0, v3=0, v4=0;	// les angles  vrifier
    
    // principe de rsolution :
//	1-------------2------3
//	|					 |
//	|	 M		  		 |
//	|			  		 |
//	|					 |
//	|			  		 |
//	|			  		 |
//	|					 |
//	|			  		 |
//	|			  		 |
//	|					 |
//	|			  		 |
//	|			  		 |
//	+----------4---------+
    // on note :
    //	C12 le cercle qui passe par B1 et B2 et M (le robot)
    //	C13 "          "            B1 et B3 et M
    //  C23 "         "             B2 et B3 et M
    //  C34 "			"           B3 et B4 et M
    //  C14 "			"           B1 et B4 et M

    // par dfaut on va calculer l'intersection des cercles C13 et [C3 ou C4]
    // mais si C13 est trop "plat", cad alpha1+alpha2 est trop proche de pi
    // on va choisir, parmi alpha1 et alpha2, le moins proche de 0 ou pi
    // cela correspond au cercle C12 ou C23
    // et on l'intersecte avec son voisin immdiat (C14 ou C34)

    // on a donc 4 config possibles :
    //		C13 inter C34
    //		C13 inter C14
    //		C12 inter C14
    //		C23 inter C34

    if( fabs(alpha1+alpha2-pi)>1 ){
//    if( meth==1 || meth==2 ){
		// ce sera C13 ...
        a1 = 0;
        b1 = -_L/tan( alpha1+alpha2 );
		v1 = 1;

    	if( fabs(alpha3-pi2)<fabs(alpha4-pi2) ){
//        if( meth==1 ){
        	// ... inter C34
            a2 =  (_L-_l/tan(alpha3))/2;
            b2 = (-_l+ _L/tan(alpha3))/2;
            x0 = _L;
            y0 = 0;

            v4 = 1;
        }else{
        	// ... inter C14
            a2 =  (-_L+_l/tan(alpha4))/2;
            b2 = (-_l+ _L/tan(alpha4))/2;
            x0 = -_L;
            y0 = 0;

            v3 = 1;
        }

    }else{

    	if( fabs(alpha1-pi2)<fabs(alpha2-pi2) ){
//        if( meth==3 ){
        	// ce sera C12 inter C14
		    a1 = (_d-_L)/2.0;
            b1 = -(_L+_d)/2.0/tan(alpha1);
            a2 =  (-_L+_l/tan(alpha4))/2;
            b2 = (-_l+ _L/tan(alpha4))/2;
            x0 = -_L;
            y0 = 0;

            v2 = 1; v3 = 1;

        }else{
        	// ce sera C23 inter C34
			a1 = (_L+_d)/2.0;
            b1 = -(_L-_d)/2.0/tan(alpha2);
            a2 =  (_L-_l/tan(alpha3))/2;
            b2 = (-_l+ _L/tan(alpha3))/2;
            x0 = _L;
            y0 = 0;

			v1 = 1; v4 = 1;
        }
    }


	IntersectCercles( a1, b1, a2, b2, x0, y0, X, Y );
	
	// vrifications :

	if( v1==1 ){
		// vrification alpha1 :
		if( couleur==BLEU )
			alpha = Angle( -_L, 0, _d, 0, *X, *Y );
		else
			alpha = Angle( -_L, 0, -_d, 0, *X, *Y );
	    ecart = fabs(alpha-alpha1);
	    score += ecart;
	}
	
	if( v2==1 ){
		// vrification alpha2 :
		if( couleur==BLEU )
			alpha = Angle(  _d, 0, _L, 0, *X, *Y );
		else
			alpha = Angle(  -_d, 0, _L, 0,*X, *Y );
	    ecart = fabs(alpha-alpha2);
	    score += ecart;
	}
	
	if( v3==1 ){
		// vrification alpha3 :
    	alpha=Angle( 0, -_l, _L, 0, *X, *Y );
        if( *Y<(*X/_L-1)*_l )
            alpha = 2*pi-alpha;
    	ecart = fabs(alpha-alpha3);
	    score += ecart;
		
	}
	
	if( v4==1 ){
		// vrification alpha4 :
    	alpha=Angle( 0, -_l, -_L, 0, *X, *Y );
        if( *Y<-(*X/_L+1)*_l )
            alpha = 2*pi-alpha;
    	ecart = fabs(alpha-alpha4);
	    score += ecart;
	}
		
    return( score );
}	

#ifdef VERSION_PRECEDENTE
//    if( fabs(alpha1+alpha2-pi)>1 ){
		// ce sera C13 ...
        a1 = 0;
        b1 = -_L/tan( alpha1+alpha2 );

    	if( fabs(alpha3-pi2)<fabs(alpha4-pi2) ){
        	// ... inter C34
            a2 =  (_L-_l/tan(alpha3))/2;
            b2 = (-_l+ _L/tan(alpha3))/2;
            x0 = _L;
            y0 = 0;
            methode=1;
        }else{
        	// ... inter C14
            a2 =  (-_L+_l/tan(alpha4))/2;
            b2 = (-_l+ _L/tan(alpha4))/2;
            x0 = -_L;
            y0 = 0;
            methode=2;
        }
/*
    }else{

    	if( fabs(alpha1-pi2)<fabs(alpha2-pi2) ){
        	// ce sera C12 inter C14
		    a1 = (_d-_L)/2;
            b1 = (_L+_d)/2/tan(-alpha1);
            a2 =  (-_L+_l/tan(alpha4))/2;
            b2 = (-_l+ _L/tan(alpha4))/2;
            x0 = -_L;
            y0 = 0;
        }else{
        	// ce sera C23 inter C34
			a1 = (_L+_d)/2;
            b1 = (_L-_d)/2/tan(-alpha2);
            a2 =  (_L-_l/tan(alpha3))/2;
            b2 = (-_l+ _L/tan(alpha3))/2;
            x0 = _L;
            y0 = 0;
        }
    }
*/

	IntersectCercles( a1, b1, a2, b2, x0, y0, X, Y );

	// vrification 1 :
	if( couleur==BLEU )
		alpha = Angle( -_L, 0, _d, 0, *X, *Y );
	else
		alpha = Angle( -_L, 0, -_d, 0, *X, *Y );
    ecart = fabs(alpha-alpha1);

    score += ecart;

    // vrification 2 :
    if( methode==1 ){
    	alpha=Angle( 0, -_l, -_L, 0, *X, *Y );
        if( *Y<-(*X/_L+1)*_l )
            alpha = 2*pi-alpha;
    	ecart = fabs(alpha-alpha4);
    }else{
    	alpha=Angle( 0, -_l, _L, 0, *X, *Y );
        if( *Y<(*X/_L-1)*_l )
            alpha = 2*pi-alpha;
    	ecart = fabs(alpha-alpha3);
    }

    score += ecart;
    return( score );
}
#endif


int GuessPosition(float * baliz, struct TPos *pos, int * nbpos){
    float a[4];
    int i, ok=0, accepte = 0;
    float X, Y, score;
    TrierAngles(baliz, 4);

    a[0] = baliz[1]-baliz[0];
    a[1] = baliz[2]-baliz[1];
    a[2] = baliz[3]-baliz[2];
    a[3] = baliz[0]-baliz[3]+2*pi;

	*nbpos = 0;
	for( i=0; i<4; i++ ){
//	        if( a[0]+a[1]<pi && a[2]>=0.8 && a[3]>=0.8 ){
                score = CalcXY( a[0], a[1], a[2], a[3], &X, &Y );
                accepte = ( -_L<=X && X<=_L && -_l<=Y && Y<=0 );
                if( !accepte ) score = 50*score;
	            printf( "candidat %d: (%d,%d) --> score=%d\n", i, (int)X, (int)Y, (int)(100*score) );
                
	            if( score<0.1 ){
		            	float Psi;
						Psi =  fabs(atan( _L/Y)) - baliz[0];
						
						if( couleur==BLEU ){
	                        pos[*nbpos].X = -Y;
	                        pos[*nbpos].Y = X+_L;
	                        pos[*nbpos].Psi = (int)(1000*Psi);
	                     }else{
	                        pos[*nbpos].X = _l+Y;
	                        pos[*nbpos].Y = _L-X;
	                        pos[*nbpos].Psi = (int)(1000*Psi);
		                 }
                        (*nbpos)++;
                }
                
//            }
            
            // permutation suivante :
            PermutCircu( a, 4);
    }
    return (*nbpos);
}

