#ifndef __TRIANGULATION_H
#define __TRIANGULATION_H

#define _d	((_L)-580)
#define _L	(2100/2)
#define _l	(3000)
#define pi	3.1415926535898
#define pi2 1.5707963267949 

#define BLEU	1
#define ROUGE 	-1

struct TPos {
	int X;
	int Y;
	int Psi;	
};

extern int couleur;


// Trier un tableau de nb lments
void TrierAngles(float * tab, int nb);

// permuter un tableau de nb lments
void PermutCircu(float *tab, int nb);

float Angle( float xa, float ya, float xb, float yb, float x, float y );

// calculer l'intersection de deux cercles si on connat un des 2 points d'intersection
//	(a1, b1) : le centre du 1er cercle
//	(a2, b2) : le centre du 2me cercle
//	(x0, y0) : un des deux points d'intersection
//	(*X, *Y) : l'autre point d'intersection
void IntersectCercles( float a1, float b1, float a2, float b2, float x0, float y0,  float *X, float *Y );

// calculer la position du robot connaissant les 4 angles entre les balises
float CalcXY( float alpha1, float alpha2, float alpha3, float alpha4, float * X, float * Y );

// deviner la position  partir des angles des balises 
// baliz[] : tableau des 4 mesures d'angle des balises
// pos[] : un tableau rcuprant les valeurs x, y de chaque point candidat
// nbpos : le nombre de points candidats trouvs
int GuessPosition(float * baliz, struct TPos *pos, int *nbpos);

#endif
