// Fichier Led.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Librairie de gestion des Leds		*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *  Les CAN doivent tre dsactive                     *
 ********************************************************/
#ifndef __LED_H__
#define __LED_H__




#define 	LED_AMBRE				PORTAbits.RA5			// Led ambre (active  l'tat bas)
#define 	LED_ROUGE				PORTAbits.RA0			// Led rouge (active  l'tat bas)

#define 	TRIS_LED_AMBRE			TRISAbits.TRISA5		// Direction du port
#define 	TRIS_LED_ROUGE			TRISAbits.TRISA0		// Direction du port




// --------------------------------------------------------------------------
/* Initialise les port des leds en sortie
 *  Pas de paramtre
*/
void Led_Init (void);




// --------------------------------------------------------------------------
/* Commande la led ambre
 *  0 = Led teinte
 *  1 =Led allume
*/
void Led_Ambre (unsigned char);






// --------------------------------------------------------------------------
/* Commande la led rouge
 *  0 = Led teinte
 *  1 =Led allume
*/
void Led_Rouge (unsigned char);


#endif
