// Fichier Serial.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <p18f452.h>			// Librairie du PIC utilis
#include <usart.h>				// Librairie pour la liaison srie


#include "serial.h"	






// --------------------------------------------------------------------------
/* Initialise le port de la led rouge en sortie
 *  Pas de paramtre
*/
void Serial_Init()
{
	TRIS_RX=1;								// RX en entre (rception)
	TRIS_TX=0;								// TX en sortie (transmission)

	//IPR1bits.RCIP=1;						// Dfini l'IT de la liasion srie comme priorit haute 

	// Configure la liaison srie  57600 Bauds:
	OpenUSART	(	USART_TX_INT_OFF	&	// Pas d'interruption sur l'mission
					USART_RX_INT_OFF	&	// Interruption sur la rception
					USART_ASYNCH_MODE	&	// Mode asynchrone
					USART_EIGHT_BIT		& 	// Transmission sur 8 bits (1 octet)
					USART_CONT_RX		&	// Reception continue
					USART_BRGH_HIGH		,	// Haute vitesse
					10);					// 21 = (20e6 / (16*57600) -1
 
	while (DataRdyUSART())					// Tant qu'il y a des donnes sur le buffer
		ReadUSART();						// on lit les donnes
}	




